# -*- coding: utf-8 -*-

"""
gumletrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from gumletrestapis.api_helper import APIHelper
from gumletrestapis.models.additional_track_1 import AdditionalTrack1
from gumletrestapis.models.transformations_3 import Transformations3


class Input3(object):

    """Implementation of the 'Input3' model.

    Attributes:
        transformations (Transformations3): The model property of type
            Transformations3.
        source_url (str): The model property of type str.
        size (int): The model property of type int.
        duration (float): The model property of type float.
        aspect_ratio (str): The model property of type str.
        fps (int): The model property of type int.
        width (int): The model property of type int.
        height (int): The model property of type int.
        additional_tracks (List[AdditionalTrack1]): The model property of type
            List[AdditionalTrack1].

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "transformations": 'transformations',
        "source_url": 'source_url',
        "size": 'size',
        "duration": 'duration',
        "aspect_ratio": 'aspect_ratio',
        "fps": 'fps',
        "width": 'width',
        "height": 'height',
        "additional_tracks": 'additional_tracks'
    }

    _optionals = [
        'transformations',
        'source_url',
        'size',
        'duration',
        'aspect_ratio',
        'fps',
        'width',
        'height',
        'additional_tracks',
    ]

    def __init__(self,
                 transformations=APIHelper.SKIP,
                 source_url=APIHelper.SKIP,
                 size=0,
                 duration=0,
                 aspect_ratio=APIHelper.SKIP,
                 fps=0,
                 width=0,
                 height=0,
                 additional_tracks=APIHelper.SKIP):
        """Constructor for the Input3 class"""

        # Initialize members of the class
        if transformations is not APIHelper.SKIP:
            self.transformations = transformations 
        if source_url is not APIHelper.SKIP:
            self.source_url = source_url 
        self.size = size 
        self.duration = duration 
        if aspect_ratio is not APIHelper.SKIP:
            self.aspect_ratio = aspect_ratio 
        self.fps = fps 
        self.width = width 
        self.height = height 
        if additional_tracks is not APIHelper.SKIP:
            self.additional_tracks = additional_tracks 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        transformations = Transformations3.from_dictionary(dictionary.get('transformations')) if 'transformations' in dictionary.keys() else APIHelper.SKIP
        source_url = dictionary.get("source_url") if dictionary.get("source_url") else APIHelper.SKIP
        size = dictionary.get("size") if dictionary.get("size") else 0
        duration = dictionary.get("duration") if dictionary.get("duration") else 0
        aspect_ratio = dictionary.get("aspect_ratio") if dictionary.get("aspect_ratio") else APIHelper.SKIP
        fps = dictionary.get("fps") if dictionary.get("fps") else 0
        width = dictionary.get("width") if dictionary.get("width") else 0
        height = dictionary.get("height") if dictionary.get("height") else 0
        additional_tracks = None
        if dictionary.get('additional_tracks') is not None:
            additional_tracks = [AdditionalTrack1.from_dictionary(x) for x in dictionary.get('additional_tracks')]
        else:
            additional_tracks = APIHelper.SKIP
        # Return an object of this model
        return cls(transformations,
                   source_url,
                   size,
                   duration,
                   aspect_ratio,
                   fps,
                   width,
                   height,
                   additional_tracks)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'transformations={(self.transformations if hasattr(self, "transformations") else None)!r}, '
                f'source_url={(self.source_url if hasattr(self, "source_url") else None)!r}, '
                f'size={(self.size if hasattr(self, "size") else None)!r}, '
                f'duration={(self.duration if hasattr(self, "duration") else None)!r}, '
                f'aspect_ratio={(self.aspect_ratio if hasattr(self, "aspect_ratio") else None)!r}, '
                f'fps={(self.fps if hasattr(self, "fps") else None)!r}, '
                f'width={(self.width if hasattr(self, "width") else None)!r}, '
                f'height={(self.height if hasattr(self, "height") else None)!r}, '
                f'additional_tracks={(self.additional_tracks if hasattr(self, "additional_tracks") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'transformations={(self.transformations if hasattr(self, "transformations") else None)!s}, '
                f'source_url={(self.source_url if hasattr(self, "source_url") else None)!s}, '
                f'size={(self.size if hasattr(self, "size") else None)!s}, '
                f'duration={(self.duration if hasattr(self, "duration") else None)!s}, '
                f'aspect_ratio={(self.aspect_ratio if hasattr(self, "aspect_ratio") else None)!s}, '
                f'fps={(self.fps if hasattr(self, "fps") else None)!s}, '
                f'width={(self.width if hasattr(self, "width") else None)!s}, '
                f'height={(self.height if hasattr(self, "height") else None)!s}, '
                f'additional_tracks={(self.additional_tracks if hasattr(self, "additional_tracks") else None)!s})')
