# -*- coding: utf-8 -*-

"""
gumletrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from gumletrestapis.api_helper import APIHelper


class OrgWebhooksRequest1(object):

    """Implementation of the 'Org Webhooks Request1' model.

    Attributes:
        url (str): URL from the application you want to send data to.
        secret_token (str): Authentication token to ensure legitimacy of
            Gumlet Webhook request on your application.
        triggers (str): Triggers for the invocation of webhookos, supported
            option is `status`.
        sources (str): List of video collection identifiers for which webhooks
            are needed to be invoked.

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "url": 'url',
        "secret_token": 'secret_token',
        "triggers": 'triggers',
        "sources": 'sources'
    }

    _optionals = [
        'url',
        'secret_token',
        'triggers',
        'sources',
    ]

    def __init__(self,
                 url=APIHelper.SKIP,
                 secret_token=APIHelper.SKIP,
                 triggers=APIHelper.SKIP,
                 sources=APIHelper.SKIP):
        """Constructor for the OrgWebhooksRequest1 class"""

        # Initialize members of the class
        if url is not APIHelper.SKIP:
            self.url = url 
        if secret_token is not APIHelper.SKIP:
            self.secret_token = secret_token 
        if triggers is not APIHelper.SKIP:
            self.triggers = triggers 
        if sources is not APIHelper.SKIP:
            self.sources = sources 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        url = dictionary.get("url") if dictionary.get("url") else APIHelper.SKIP
        secret_token = dictionary.get("secret_token") if dictionary.get("secret_token") else APIHelper.SKIP
        triggers = dictionary.get("triggers") if dictionary.get("triggers") else APIHelper.SKIP
        sources = dictionary.get("sources") if dictionary.get("sources") else APIHelper.SKIP
        # Return an object of this model
        return cls(url,
                   secret_token,
                   triggers,
                   sources)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'url={(self.url if hasattr(self, "url") else None)!r}, '
                f'secret_token={(self.secret_token if hasattr(self, "secret_token") else None)!r}, '
                f'triggers={(self.triggers if hasattr(self, "triggers") else None)!r}, '
                f'sources={(self.sources if hasattr(self, "sources") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'url={(self.url if hasattr(self, "url") else None)!s}, '
                f'secret_token={(self.secret_token if hasattr(self, "secret_token") else None)!s}, '
                f'triggers={(self.triggers if hasattr(self, "triggers") else None)!s}, '
                f'sources={(self.sources if hasattr(self, "sources") else None)!s})')
