# -*- coding: utf-8 -*-

"""
gumletrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
import dateutil.parser

from gumletrestapis.api_helper import APIHelper


class Timeframe2(object):

    """Implementation of the 'Timeframe2' model.

    The timeframe to get the data for. Currently we only support maximum
    difference between `start_at` and `end_at` to be *60 days*

    Attributes:
        start_at (date): Use <b>yyyy-MM-dd</b> format
        end_at (date): Use <b>yyyy-MM-dd</b> format

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "start_at": 'start_at',
        "end_at": 'end_at'
    }

    _optionals = [
        'start_at',
        'end_at',
    ]

    def __init__(self,
                 start_at=APIHelper.SKIP,
                 end_at=APIHelper.SKIP):
        """Constructor for the Timeframe2 class"""

        # Initialize members of the class
        if start_at is not APIHelper.SKIP:
            self.start_at = start_at 
        if end_at is not APIHelper.SKIP:
            self.end_at = end_at 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        start_at = dateutil.parser.parse(dictionary.get('start_at')).date() if dictionary.get('start_at') else APIHelper.SKIP
        end_at = dateutil.parser.parse(dictionary.get('end_at')).date() if dictionary.get('end_at') else APIHelper.SKIP
        # Return an object of this model
        return cls(start_at,
                   end_at)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'start_at={(self.start_at if hasattr(self, "start_at") else None)!r}, '
                f'end_at={(self.end_at if hasattr(self, "end_at") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'start_at={(self.start_at if hasattr(self, "start_at") else None)!s}, '
                f'end_at={(self.end_at if hasattr(self, "end_at") else None)!s})')
