# -*- coding: utf-8 -*-

"""
gumletrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from gumletrestapis.api_helper import APIHelper
from gumletrestapis.models.all_asset import AllAsset


class VideoAssetsListResponse(object):

    """Implementation of the 'Video Assets List Response' model.

    Attributes:
        all_assets (List[AllAsset]): The model property of type List[AllAsset].
        total_asset_count (int): The model property of type int.
        current_offset (int): The model property of type int.
        distinct_tags (List[str]): The model property of type List[str].

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "all_assets": 'all_assets',
        "total_asset_count": 'total_asset_count',
        "current_offset": 'current_offset',
        "distinct_tags": 'distinct_tags'
    }

    _optionals = [
        'all_assets',
        'total_asset_count',
        'current_offset',
        'distinct_tags',
    ]

    def __init__(self,
                 all_assets=APIHelper.SKIP,
                 total_asset_count=0,
                 current_offset=0,
                 distinct_tags=APIHelper.SKIP):
        """Constructor for the VideoAssetsListResponse class"""

        # Initialize members of the class
        if all_assets is not APIHelper.SKIP:
            self.all_assets = all_assets 
        self.total_asset_count = total_asset_count 
        self.current_offset = current_offset 
        if distinct_tags is not APIHelper.SKIP:
            self.distinct_tags = distinct_tags 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        all_assets = None
        if dictionary.get('all_assets') is not None:
            all_assets = [AllAsset.from_dictionary(x) for x in dictionary.get('all_assets')]
        else:
            all_assets = APIHelper.SKIP
        total_asset_count = dictionary.get("total_asset_count") if dictionary.get("total_asset_count") else 0
        current_offset = dictionary.get("current_offset") if dictionary.get("current_offset") else 0
        distinct_tags = dictionary.get("distinct_tags") if dictionary.get("distinct_tags") else APIHelper.SKIP
        # Return an object of this model
        return cls(all_assets,
                   total_asset_count,
                   current_offset,
                   distinct_tags)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'all_assets={(self.all_assets if hasattr(self, "all_assets") else None)!r}, '
                f'total_asset_count={(self.total_asset_count if hasattr(self, "total_asset_count") else None)!r}, '
                f'current_offset={(self.current_offset if hasattr(self, "current_offset") else None)!r}, '
                f'distinct_tags={(self.distinct_tags if hasattr(self, "distinct_tags") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'all_assets={(self.all_assets if hasattr(self, "all_assets") else None)!s}, '
                f'total_asset_count={(self.total_asset_count if hasattr(self, "total_asset_count") else None)!s}, '
                f'current_offset={(self.current_offset if hasattr(self, "current_offset") else None)!s}, '
                f'distinct_tags={(self.distinct_tags if hasattr(self, "distinct_tags") else None)!s})')
