# -*- coding: utf-8 -*-

"""
gumletrestapis

This file was automatically generated by APIMATIC v3.0 (
 https://www.apimatic.io ).
"""
from gumletrestapis.api_helper import APIHelper
from gumletrestapis.models.input_1 import Input1
from gumletrestapis.models.output import Output


class VideoAssetsUploadResponse(object):

    """Implementation of the 'Video Assets Upload Response' model.

    Attributes:
        asset_id (str): The model property of type str.
        progress (int): The model property of type int.
        created_at (int): The model property of type int.
        updated_at (int): The model property of type int.
        status (str): The model property of type str.
        tag (List[str]): The model property of type List[str].
        source_id (str): The model property of type str.
        collection_id (str): The model property of type str.
        input (Input1): The model property of type Input1.
        output (Output): The model property of type Output.
        upload_url (str): The model property of type str.
        playlists (List[str]): The model property of type List[str].

    """

    # Create a mapping from Model property names to API property names
    _names = {
        "asset_id": 'asset_id',
        "progress": 'progress',
        "created_at": 'created_at',
        "updated_at": 'updated_at',
        "status": 'status',
        "tag": 'tag',
        "source_id": 'source_id',
        "collection_id": 'collection_id',
        "input": 'input',
        "output": 'output',
        "upload_url": 'upload_url',
        "playlists": 'playlists'
    }

    _optionals = [
        'asset_id',
        'progress',
        'created_at',
        'updated_at',
        'status',
        'tag',
        'source_id',
        'collection_id',
        'input',
        'output',
        'upload_url',
        'playlists',
    ]

    def __init__(self,
                 asset_id=APIHelper.SKIP,
                 progress=0,
                 created_at=0,
                 updated_at=0,
                 status=APIHelper.SKIP,
                 tag=APIHelper.SKIP,
                 source_id=APIHelper.SKIP,
                 collection_id=APIHelper.SKIP,
                 input=APIHelper.SKIP,
                 output=APIHelper.SKIP,
                 upload_url=APIHelper.SKIP,
                 playlists=APIHelper.SKIP):
        """Constructor for the VideoAssetsUploadResponse class"""

        # Initialize members of the class
        if asset_id is not APIHelper.SKIP:
            self.asset_id = asset_id 
        self.progress = progress 
        self.created_at = created_at 
        self.updated_at = updated_at 
        if status is not APIHelper.SKIP:
            self.status = status 
        if tag is not APIHelper.SKIP:
            self.tag = tag 
        if source_id is not APIHelper.SKIP:
            self.source_id = source_id 
        if collection_id is not APIHelper.SKIP:
            self.collection_id = collection_id 
        if input is not APIHelper.SKIP:
            self.input = input 
        if output is not APIHelper.SKIP:
            self.output = output 
        if upload_url is not APIHelper.SKIP:
            self.upload_url = upload_url 
        if playlists is not APIHelper.SKIP:
            self.playlists = playlists 

    @classmethod
    def from_dictionary(cls,
                        dictionary):
        """Creates an instance of this model from a dictionary

        Args:
            dictionary (dictionary): A dictionary representation of the object
            as obtained from the deserialization of the server's response. The
            keys MUST match property names in the API description.

        Returns:
            object: An instance of this structure class.

        """

        if not isinstance(dictionary, dict) or dictionary is None:
            return None

        # Extract variables from the dictionary
        asset_id = dictionary.get("asset_id") if dictionary.get("asset_id") else APIHelper.SKIP
        progress = dictionary.get("progress") if dictionary.get("progress") else 0
        created_at = dictionary.get("created_at") if dictionary.get("created_at") else 0
        updated_at = dictionary.get("updated_at") if dictionary.get("updated_at") else 0
        status = dictionary.get("status") if dictionary.get("status") else APIHelper.SKIP
        tag = dictionary.get("tag") if dictionary.get("tag") else APIHelper.SKIP
        source_id = dictionary.get("source_id") if dictionary.get("source_id") else APIHelper.SKIP
        collection_id = dictionary.get("collection_id") if dictionary.get("collection_id") else APIHelper.SKIP
        input = Input1.from_dictionary(dictionary.get('input')) if 'input' in dictionary.keys() else APIHelper.SKIP
        output = Output.from_dictionary(dictionary.get('output')) if 'output' in dictionary.keys() else APIHelper.SKIP
        upload_url = dictionary.get("upload_url") if dictionary.get("upload_url") else APIHelper.SKIP
        playlists = dictionary.get("playlists") if dictionary.get("playlists") else APIHelper.SKIP
        # Return an object of this model
        return cls(asset_id,
                   progress,
                   created_at,
                   updated_at,
                   status,
                   tag,
                   source_id,
                   collection_id,
                   input,
                   output,
                   upload_url,
                   playlists)

    def __repr__(self):
        return (f'{self.__class__.__name__}('
                f'asset_id={(self.asset_id if hasattr(self, "asset_id") else None)!r}, '
                f'progress={(self.progress if hasattr(self, "progress") else None)!r}, '
                f'created_at={(self.created_at if hasattr(self, "created_at") else None)!r}, '
                f'updated_at={(self.updated_at if hasattr(self, "updated_at") else None)!r}, '
                f'status={(self.status if hasattr(self, "status") else None)!r}, '
                f'tag={(self.tag if hasattr(self, "tag") else None)!r}, '
                f'source_id={(self.source_id if hasattr(self, "source_id") else None)!r}, '
                f'collection_id={(self.collection_id if hasattr(self, "collection_id") else None)!r}, '
                f'input={(self.input if hasattr(self, "input") else None)!r}, '
                f'output={(self.output if hasattr(self, "output") else None)!r}, '
                f'upload_url={(self.upload_url if hasattr(self, "upload_url") else None)!r}, '
                f'playlists={(self.playlists if hasattr(self, "playlists") else None)!r})')

    def __str__(self):
        return (f'{self.__class__.__name__}('
                f'asset_id={(self.asset_id if hasattr(self, "asset_id") else None)!s}, '
                f'progress={(self.progress if hasattr(self, "progress") else None)!s}, '
                f'created_at={(self.created_at if hasattr(self, "created_at") else None)!s}, '
                f'updated_at={(self.updated_at if hasattr(self, "updated_at") else None)!s}, '
                f'status={(self.status if hasattr(self, "status") else None)!s}, '
                f'tag={(self.tag if hasattr(self, "tag") else None)!s}, '
                f'source_id={(self.source_id if hasattr(self, "source_id") else None)!s}, '
                f'collection_id={(self.collection_id if hasattr(self, "collection_id") else None)!s}, '
                f'input={(self.input if hasattr(self, "input") else None)!s}, '
                f'output={(self.output if hasattr(self, "output") else None)!s}, '
                f'upload_url={(self.upload_url if hasattr(self, "upload_url") else None)!s}, '
                f'playlists={(self.playlists if hasattr(self, "playlists") else None)!s})')
